# Patched ADIN1100 Driver for USB-SPEmodul series

Old Kernel versions may have a Kernel nullptr exception with unpatched ADIN1100 driver.

## Requirements

* Linux Kernel version >= 6.1.0
* Following kernel options have to be set:

```text
CONFIG_NETDEVICES=[y/m]
CONFIG_USB_NET_DRIVERS=[y/m]
CONFIG_USB_USBNET=[y/m]
CONFIG_USB_NET_SMSC95XX=[y/m]
CONFIG_PHYLIB=[y/m]
```

## Installation

### Installation via DKMS

If you want to install the driver manually, please jump to the next section.

The advantage of DKMS is that the driver will be built and installed
automatically for every new Linux kernel version which is installed on the
system.

1. Remove old driver versions
   (necessary only if driver has been installed manually).

```shell
$ sudo find /lib/modules/ -type f -name "adin1100.ko*" -exec rm -f {} \;
```

2. Add, build and install new driver from the current directory:

```shell
$ sudo dkms install .
```

### Building the patched driver

Run make within the source directory

```shell
$ cd systec_spe
$ make
```

### Loading the driver from the local source directory

1. Load basic smsc95xx driver

```shell
$ sudo modprobe smsc95xx
```

2. Load patched ADIN1100 driver for SPEmodul

```shell
$ sudo insmod adin1100.ko
```

### Installing the driver and firmware system-wide


```shell
$ sudo make modules_install
```

The kernel module should now be loaded automatically by udev
when the device is connected.

## Further information

* Linux Kernel Source Code

    <http://git.kernel.org/?p=linux/kernel/git/torvalds/linux.git>
